/* CIS 694I, Lab 2 
This program uses a SET class to perform operations on a 1000(maxelems)-member
set of positive integers */

/*INPUT:  1)User input of an integer from 0 to 6 to select a desired function
          2)Optional additional user input required for requested function

  OUTPUT: 1)Execution of requested function
          2)Error messages for invalid inputs
	  3)Error messages for duplicate entries for "insert" function
*/

#include <iostream.h>
#include <stdio.h>

// extern void set_debug_traps(void);
// extern void breakpoint(void);

const int maxelems = 10;	// Global variable for  max set size
// Function Declarations

void DisplayMenu();

// Set Class Definition

class Set {
 public:
  Set();
  void ReportSetSize();
  void InsertElements();
  void DeleteElements();
  void ReportElements();

 private:
  int *myset;
};

main()
{
  if (setvbuf(stdout,NULL,_IONBF,1)!=0)
    perror("my error");
  

//   set_debug_traps();   
//   breakpoint();

  Set dummyset; 		 //a dummy set for now
  int usrin ;

  DisplayMenu();  		// Initial menu display
  while(1)			// Start infinite loop
    {
    cout << '\n';

    if(cin >> usrin == 0)	// check for non-integer input
    {
      cerr << "Only positive integers and zero allowed\n";
      break;
    }
    
    switch ( usrin )
      {
      case 0:
	DisplayMenu();
	break;
      case 1:
	dummyset.ReportSetSize();
	break;
      case 2:
	dummyset.InsertElements();
	break;
      case 3:
	dummyset.DeleteElements();
	break;
      case 4:
	cout << "this is case 4";
	break;
      case 5:
	dummyset.ReportElements();
	break;
      case 6:
	return 0;		// Quit the program
      default:
	cerr << "Invalid Choice.  Enter 0-6. (This is the default case)";
    }
  }
}


// FUNCTION DEFINITIONS
//----------------------------------------------------------
void DisplayMenu()
{
  cout << '\n'			// put out newline 
       << "0. Print this menu. \n"
       << "1. Report set size. \n"
       << "2. Insert elements. \n"
       << "3. Delete elements. \n"
       << "4. Is element present? \n"
       << "5. Report set elements. \n"
       << "6. Quit program. \n";
};

//----------------------------------------------------------
Set::Set()			//Set class Constructor function
{
  int i;
  myset = new int[maxelems-1];	// Set up maxelems-element array
  for (i=0;i<maxelems;i++)	// initialize to all zeros
	myset[i]=0;	
}

//----------------------------------------------------------
void Set::ReportSetSize()	// Case 1
{
  int i;
  for (i=0;myset[i]!= 0 && i < maxelems;i++);	// Count non-zero elements
  cout << "Set size is " << i << endl;
};

//----------------------------------------------------------
void Set::InsertElements()	// Case 2
{
  int insertnum, i, skip;
  cout << "Input Positive Integers\n";
  while(cin >> insertnum )
  {
    if (insertnum < 0)		// Check for negative numbers
    {
      cerr << "Invalid input\n";
      break;
    }
    if (insertnum == 0) break;	// Break on input of zero

// Must be a positive integer, so insert in next avail spot

    skip = 0;			// set skip to false
    for (i=0; myset[i]!= 0 && i <= maxelems; i++)	// Find first zero el
    {
      if (myset[i] == insertnum)	// If duplicate, don't insert
      {
        cerr << "Duplicate Entry " << insertnum << endl;
	skip = 1;
        break;
      }
    }
    if(i >= maxelems)		// if set full, don't perform insert
    {
      cerr << "Set is Full. Can't insert " << insertnum << endl;
      skip = 1;
    }


    if(skip == 0) myset[i] = insertnum; // If all OK, insert new element

  };
};

//----------------------------------------------------------
void Set::DeleteElements()	// This is case 3
{
  int delnum, i, found;
  cout << "Input Positive Integers\n";
  while(cin >> delnum )
  {
    if (delnum < 0)		// Check for negative numbers
    {
      cerr << "Invalid input\n";
      break;
    };
    if (delnum == 0) break;	// Break on input of zero

// Must be a positive integer, so delete if in set

    found = 0;
    for (i=0; myset[i]!=0 && i <= maxelems; i++)
    {
      if (myset[i] == delnum)	//found, delete & readjust elements
      {
	found = 1;	
	// logic if for is wrong; && myset[i] != 0
	for(i=i; i< maxelems || myset[i]== 0; i++)
	{
	  myset[i] = myset[i+1];	// drop els down by one
	};	  
//	if (i == maxelems) myset[i] = 0;	//covers full set case
	if (i == maxelems) myset[i-1] = 0;	//covers full set case
      };
    };
    if(!found) cerr << "Couldn't Find " << delnum << endl;
  };
};

  
//----------------------------------------------------------
void Set::ReportElements()	// This is case 5
{
  int i;
  for (i=0;myset[i]!=0 && i < maxelems;i++)	// til zero el or end of set
  {
    cout << myset[i] << ' ';	// Output the ith element and a space
  }
  cout << endl;			// Output an endline command

};
  



















